DROP INDEX EVENT_TYPE;
DROP INDEX EVENT_DATE;
DROP INDEX EVENT_DETAIL_EVENT_ID;

DROP TABLE EVENT_DETAIL;
DROP TABLE EVENT;

DROP SEQUENCE EVENT_DETAIL_SEQ;
DROP SEQUENCE EVENT_SEQ;

CREATE SEQUENCE EVENT_LOG_SEQ;

CREATE TABLE EVENT_LOG
(
    EVENT_ID INTEGER DEFAULT NEXT VALUE FOR EVENT_LOG_SEQ NOT NULL,
    EVENT_TYPE_ID INTEGER NOT NULL,
    EVENT_DATE TIMESTAMP DEFAULT CURRENT_TIMESTAMP NOT NULL,
    USER_LOGIN CHARACTER VARYING(50) NOT NULL,
    PERS_ID INTEGER,
    PERS_FIO CHARACTER VARYING(152),
    PERS_NUMB_T2 INTEGER,
    PERS_WDEND TIMESTAMP,
    EVENT_DETAILS CHARACTER VARYING,
    CONSTRAINT EVENT_LOG_PK
        PRIMARY KEY (EVENT_ID)
);

CREATE TABLE EVENT_TYPE
(
    ID INTEGER NOT NULL,
    NAME CHARACTER VARYING(255) NOT NULL,
    CONSTRAINT EVENT_TYPE_PK
        PRIMARY KEY (ID)
);

INSERT INTO EVENT_TYPE (ID, NAME) VALUES (1, 'Вход в программу');
INSERT INTO EVENT_TYPE (ID, NAME) VALUES (2, 'Неудачная попытка входа в программу');
INSERT INTO EVENT_TYPE (ID, NAME) VALUES (3, 'Выход из программы');
INSERT INTO EVENT_TYPE (ID, NAME) VALUES (4, 'Создание личной карточки');
INSERT INTO EVENT_TYPE (ID, NAME) VALUES (5, 'Удаление личной карточки');
INSERT INTO EVENT_TYPE (ID, NAME) VALUES (6, 'Печать Акта об уничтожении персональных данных');
INSERT INTO EVENT_TYPE (ID, NAME) VALUES (7, 'Печать Журнала событий');
INSERT INTO EVENT_TYPE (ID, NAME) VALUES (8, 'Удаление записей из Журнала событий');

ALTER TABLE EVENT_LOG
    ADD CONSTRAINT FK_EVENT_LOG_EVENT_TYPE_ID
        FOREIGN KEY (EVENT_TYPE_ID) REFERENCES EVENT_TYPE;

CREATE INDEX EVENT_LOG_EVENT_TYPE_ID
    ON EVENT_LOG (EVENT_TYPE_ID);

CREATE INDEX EVENT_LOG_EVENT_DATE
    ON EVENT_LOG (EVENT_DATE);

CREATE INDEX EVENT_LOG_USER_LOGIN
    ON EVENT_LOG (USER_LOGIN);

